/*----- PROTECTED REGION ID(CATSyncClass.h) ENABLED START -----*/
/* clang-format on */
//=============================================================================
//
// file :        CATSyncClass.h
//
// description : Include for the CATSync root class.
//               This class is the singleton class for
//                the CATSync device class.
//               It contains all properties and methods which the
//               CATSync requires only once e.g. the commands.
//
// project :     CATSync
//
// This file is part of Tango device class.
//
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
//
//
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#ifndef CATSyncClass_H
#define CATSyncClass_H

#include <tango/tango.h>
#include "CATSync.h"

/* clang-format off */
/*----- PROTECTED REGION END -----*/	//	CATSyncClass.h


namespace CATSync_ns
{
/*----- PROTECTED REGION ID(CATSyncClass::classes for dynamic creation) ENABLED START -----*/
/* clang-format on */

/* clang-format off */
/*----- PROTECTED REGION END -----*/	//	CATSyncClass::classes for dynamic creation

//=========================================
//	Define classes for attributes
//=========================================
//	Attribute EnableCATEnergyUpdate class definition
class EnableCATEnergyUpdateAttrib: public Tango::Attr
{
public:
	EnableCATEnergyUpdateAttrib():Attr("EnableCATEnergyUpdate",
			Tango::DEV_BOOLEAN, Tango::READ_WRITE) {};
	~EnableCATEnergyUpdateAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<CATSync *>(dev))->read_EnableCATEnergyUpdate(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<CATSync *>(dev))->write_EnableCATEnergyUpdate(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<CATSync *>(dev))->is_EnableCATEnergyUpdate_allowed(ty);}
};

//	Attribute EnableCATSourcePointUpdate class definition
class EnableCATSourcePointUpdateAttrib: public Tango::Attr
{
public:
	EnableCATSourcePointUpdateAttrib():Attr("EnableCATSourcePointUpdate",
			Tango::DEV_BOOLEAN, Tango::READ_WRITE) {};
	~EnableCATSourcePointUpdateAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<CATSync *>(dev))->read_EnableCATSourcePointUpdate(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<CATSync *>(dev))->write_EnableCATSourcePointUpdate(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<CATSync *>(dev))->is_EnableCATSourcePointUpdate_allowed(ty);}
};

//	Attribute LFBCATTimeFactor class definition
class LFBCATTimeFactorAttrib: public Tango::Attr
{
public:
	LFBCATTimeFactorAttrib():Attr("LFBCATTimeFactor",
			Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~LFBCATTimeFactorAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<CATSync *>(dev))->read_LFBCATTimeFactor(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<CATSync *>(dev))->write_LFBCATTimeFactor(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<CATSync *>(dev))->is_LFBCATTimeFactor_allowed(ty);}
};

//	Attribute LFBHLSTimeFactor class definition
class LFBHLSTimeFactorAttrib: public Tango::Attr
{
public:
	LFBHLSTimeFactorAttrib():Attr("LFBHLSTimeFactor",
			Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~LFBHLSTimeFactorAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<CATSync *>(dev))->read_LFBHLSTimeFactor(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<CATSync *>(dev))->write_LFBHLSTimeFactor(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<CATSync *>(dev))->is_LFBHLSTimeFactor_allowed(ty);}
};

//	Attribute EnableCATMatchOrbit class definition
class EnableCATMatchOrbitAttrib: public Tango::Attr
{
public:
	EnableCATMatchOrbitAttrib():Attr("EnableCATMatchOrbit",
			Tango::DEV_BOOLEAN, Tango::READ_WRITE) {};
	~EnableCATMatchOrbitAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<CATSync *>(dev))->read_EnableCATMatchOrbit(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<CATSync *>(dev))->write_EnableCATMatchOrbit(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<CATSync *>(dev))->is_EnableCATMatchOrbit_allowed(ty);}
};

//	Attribute EnableCATSyncMagnets class definition
class EnableCATSyncMagnetsAttrib: public Tango::Attr
{
public:
	EnableCATSyncMagnetsAttrib():Attr("EnableCATSyncMagnets",
			Tango::DEV_BOOLEAN, Tango::READ_WRITE) {};
	~EnableCATSyncMagnetsAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<CATSync *>(dev))->read_EnableCATSyncMagnets(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<CATSync *>(dev))->write_EnableCATSyncMagnets(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<CATSync *>(dev))->is_EnableCATSyncMagnets_allowed(ty);}
};

//	Attribute CATState class definition
class CATStateAttrib: public Tango::Attr
{
public:
	CATStateAttrib():Attr("CATState",
			Tango::DEV_STATE, Tango::READ) {};
	~CATStateAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<CATSync *>(dev))->read_CATState(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<CATSync *>(dev))->is_CATState_allowed(ty);}
};

//	Attribute HLSState class definition
class HLSStateAttrib: public Tango::Attr
{
public:
	HLSStateAttrib():Attr("HLSState",
			Tango::DEV_STATE, Tango::READ) {};
	~HLSStateAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<CATSync *>(dev))->read_HLSState(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<CATSync *>(dev))->is_HLSState_allowed(ty);}
};

//	Attribute SyncGain class definition
class SyncGainAttrib: public Tango::Attr
{
public:
	SyncGainAttrib():Attr("SyncGain",
			Tango::DEV_DOUBLE, Tango::READ_WRITE) {};
	~SyncGainAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<CATSync *>(dev))->read_SyncGain(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<CATSync *>(dev))->write_SyncGain(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<CATSync *>(dev))->is_SyncGain_allowed(ty);}
};

//	Attribute CATTuneHor class definition
class CATTuneHorAttrib: public Tango::Attr
{
public:
	CATTuneHorAttrib():Attr("CATTuneHor",
			Tango::DEV_DOUBLE, Tango::READ) {};
	~CATTuneHorAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<CATSync *>(dev))->read_CATTuneHor(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<CATSync *>(dev))->is_CATTuneHor_allowed(ty);}
};

//	Attribute CATTuneVer class definition
class CATTuneVerAttrib: public Tango::Attr
{
public:
	CATTuneVerAttrib():Attr("CATTuneVer",
			Tango::DEV_DOUBLE, Tango::READ) {};
	~CATTuneVerAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<CATSync *>(dev))->read_CATTuneVer(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<CATSync *>(dev))->is_CATTuneVer_allowed(ty);}
};

//	Attribute MatchThreadErrMsg class definition
class MatchThreadErrMsgAttrib: public Tango::SpectrumAttr
{
public:
	// Constants for MatchThreadErrMsg attribute
	constexpr static long X_DATA_SIZE = 10000;
	MatchThreadErrMsgAttrib():SpectrumAttr("MatchThreadErrMsg",
			Tango::DEV_STRING, Tango::READ, MatchThreadErrMsgAttrib::X_DATA_SIZE) {};
	~MatchThreadErrMsgAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<CATSync *>(dev))->read_MatchThreadErrMsg(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<CATSync *>(dev))->is_MatchThreadErrMsg_allowed(ty);}
};

//	Attribute SyncThreadErrMsg class definition
class SyncThreadErrMsgAttrib: public Tango::SpectrumAttr
{
public:
	// Constants for SyncThreadErrMsg attribute
	constexpr static long X_DATA_SIZE = 10000;
	SyncThreadErrMsgAttrib():SpectrumAttr("SyncThreadErrMsg",
			Tango::DEV_STRING, Tango::READ, SyncThreadErrMsgAttrib::X_DATA_SIZE) {};
	~SyncThreadErrMsgAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<CATSync *>(dev))->read_SyncThreadErrMsg(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<CATSync *>(dev))->is_SyncThreadErrMsg_allowed(ty);}
};

//	Attribute MatchThreadErrCnt class definition
class MatchThreadErrCntAttrib: public Tango::SpectrumAttr
{
public:
	// Constants for MatchThreadErrCnt attribute
	constexpr static long X_DATA_SIZE = 10000;
	MatchThreadErrCntAttrib():SpectrumAttr("MatchThreadErrCnt",
			Tango::DEV_ULONG, Tango::READ, MatchThreadErrCntAttrib::X_DATA_SIZE) {};
	~MatchThreadErrCntAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<CATSync *>(dev))->read_MatchThreadErrCnt(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<CATSync *>(dev))->is_MatchThreadErrCnt_allowed(ty);}
};

//	Attribute SyncThreadErrCnt class definition
class SyncThreadErrCntAttrib: public Tango::SpectrumAttr
{
public:
	// Constants for SyncThreadErrCnt attribute
	constexpr static long X_DATA_SIZE = 10000;
	SyncThreadErrCntAttrib():SpectrumAttr("SyncThreadErrCnt",
			Tango::DEV_ULONG, Tango::READ, SyncThreadErrCntAttrib::X_DATA_SIZE) {};
	~SyncThreadErrCntAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<CATSync *>(dev))->read_SyncThreadErrCnt(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<CATSync *>(dev))->is_SyncThreadErrCnt_allowed(ty);}
};

//	Attribute MatchThreadCnt class definition
class MatchThreadCntAttrib: public Tango::SpectrumAttr
{
public:
	// Constants for MatchThreadCnt attribute
	constexpr static long X_DATA_SIZE = 10000;
	MatchThreadCntAttrib():SpectrumAttr("MatchThreadCnt",
			Tango::DEV_ULONG, Tango::READ, MatchThreadCntAttrib::X_DATA_SIZE) {};
	~MatchThreadCntAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<CATSync *>(dev))->read_MatchThreadCnt(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<CATSync *>(dev))->is_MatchThreadCnt_allowed(ty);}
};

//	Attribute SyncThreadCnt class definition
class SyncThreadCntAttrib: public Tango::SpectrumAttr
{
public:
	// Constants for SyncThreadCnt attribute
	constexpr static long X_DATA_SIZE = 10000;
	SyncThreadCntAttrib():SpectrumAttr("SyncThreadCnt",
			Tango::DEV_ULONG, Tango::READ, SyncThreadCntAttrib::X_DATA_SIZE) {};
	~SyncThreadCntAttrib() {};
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<CATSync *>(dev))->read_SyncThreadCnt(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<CATSync *>(dev))->is_SyncThreadCnt_allowed(ty);}
};


//=========================================
//	Define classes for commands
//=========================================
//	Command Start class definition
class StartClass : public Tango::Command
{
public:
	StartClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(cmd_name,in,out,in_desc,out_desc, level)	{};

	StartClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(cmd_name,in,out)	{};
	~StartClass() {};

	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<CATSync *>(dev))->is_Start_allowed(any);}
};

//	Command Stop class definition
class StopClass : public Tango::Command
{
public:
	StopClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(cmd_name,in,out,in_desc,out_desc, level)	{};

	StopClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(cmd_name,in,out)	{};
	~StopClass() {};

	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<CATSync *>(dev))->is_Stop_allowed(any);}
};

//	Command GotoEnergy class definition
class GotoEnergyClass : public Tango::Command
{
public:
	GotoEnergyClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(cmd_name,in,out,in_desc,out_desc, level)	{};

	GotoEnergyClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(cmd_name,in,out)	{};
	~GotoEnergyClass() {};

	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<CATSync *>(dev))->is_GotoEnergy_allowed(any);}
};

//	Command UpdateEnergy class definition
class UpdateEnergyClass : public Tango::Command
{
public:
	UpdateEnergyClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(cmd_name,in,out,in_desc,out_desc, level)	{};

	UpdateEnergyClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(cmd_name,in,out)	{};
	~UpdateEnergyClass() {};

	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<CATSync *>(dev))->is_UpdateEnergy_allowed(any);}
};

//	Command SyncSourcePointsToHLS class definition
class SyncSourcePointsToHLSClass : public Tango::Command
{
public:
	SyncSourcePointsToHLSClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(cmd_name,in,out,in_desc,out_desc, level)	{};

	SyncSourcePointsToHLSClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(cmd_name,in,out)	{};
	~SyncSourcePointsToHLSClass() {};

	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<CATSync *>(dev))->is_SyncSourcePointsToHLS_allowed(any);}
};

//	Command SwitchLFBCAT class definition
class SwitchLFBCATClass : public Tango::Command
{
public:
	SwitchLFBCATClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(cmd_name,in,out,in_desc,out_desc, level)	{};

	SwitchLFBCATClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(cmd_name,in,out)	{};
	~SwitchLFBCATClass() {};

	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<CATSync *>(dev))->is_SwitchLFBCAT_allowed(any);}
};

//	Command SwitchLFBHLS class definition
class SwitchLFBHLSClass : public Tango::Command
{
public:
	SwitchLFBHLSClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(cmd_name,in,out,in_desc,out_desc, level)	{};

	SwitchLFBHLSClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(cmd_name,in,out)	{};
	~SwitchLFBHLSClass() {};

	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<CATSync *>(dev))->is_SwitchLFBHLS_allowed(any);}
};

//	Command ConvertSourcePointsMM class definition
class ConvertSourcePointsMMClass : public Tango::Command
{
public:
	ConvertSourcePointsMMClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(cmd_name,in,out,in_desc,out_desc, level)	{};

	ConvertSourcePointsMMClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(cmd_name,in,out)	{};
	~ConvertSourcePointsMMClass() {};

	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<CATSync *>(dev))->is_ConvertSourcePointsMM_allowed(any);}
};

//	Command ResetSourcePointOffsets class definition
class ResetSourcePointOffsetsClass : public Tango::Command
{
public:
	ResetSourcePointOffsetsClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(cmd_name,in,out,in_desc,out_desc, level)	{};

	ResetSourcePointOffsetsClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(cmd_name,in,out)	{};
	~ResetSourcePointOffsetsClass() {};

	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<CATSync *>(dev))->is_ResetSourcePointOffsets_allowed(any);}
};


/**
 *	The CATSyncClass singleton definition
 */

#ifdef _TG_WINDOWS_
class __declspec(dllexport)  CATSyncClass : public Tango::DeviceClass
#else
class CATSyncClass : public Tango::DeviceClass
#endif
{
	/*----- PROTECTED REGION ID(CATSyncClass::Additional DServer data members) ENABLED START -----*/
	/* clang-format on */
	//	Add your own code
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	CATSyncClass::Additional DServer data members

	public:
		//	write class properties data members
		Tango::DbData	cl_prop;
		Tango::DbData	cl_def_prop;
		Tango::DbData	dev_def_prop;
		//	Method prototypes
		static CATSyncClass *init(const char *);
		static CATSyncClass *instance();
		~CATSyncClass();
		Tango::DbDatum	get_class_property(std::string &);
		Tango::DbDatum	get_default_device_property(std::string &);
		Tango::DbDatum	get_default_class_property(std::string &);

	protected:
		CATSyncClass(std::string &);
		static CATSyncClass *_instance;
		void command_factory();
		void attribute_factory(std::vector<Tango::Attr *> &);
		void pipe_factory();
		void write_class_property();
		void set_default_property();
		void get_class_property();
		std::string get_cvstag();
		std::string get_cvsroot();

	private:
		void device_factory(TANGO_UNUSED(const Tango::DevVarStringArray *));
		void create_static_attribute_list(std::vector<Tango::Attr *> &);
		void erase_dynamic_attributes(const Tango::DevVarStringArray *,std::vector<Tango::Attr *> &);
		std::vector<std::string>	defaultAttList;
		Tango::Attr *get_attr_object_by_name(std::vector<Tango::Attr *> &att_list, std::string attname);
};

}	//	End of namespace

#endif   //	CATSync_H
