/*----- PROTECTED REGION ID(CATSyncStateMachine.cpp) ENABLED START -----*/
/* clang-format on */
//=============================================================================
//
// file :        CATSyncStateMachine.cpp
//
// description : State machine file for the CATSync class
//
// project :     CATSync
//
// This file is part of Tango device class.
//
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
//
//
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================

#include "CATSync.h"

/* clang-format off */
/*----- PROTECTED REGION END -----*/	//	CATSync::CATSyncStateMachine.cpp

//================================================================
//  States  |  Description
//================================================================
//  ON      |  
//  OFF     |  
//  FAULT   |  
//  MOVING  |  


namespace CATSync_ns
{
//=================================================
//		Attributes Allowed Methods
//=================================================

//--------------------------------------------------------
/**
 *	Method      : CATSync::is_EnableCATEnergyUpdate_allowed()
 * Description:  Execution allowed for EnableCATEnergyUpdate attribute
 */
//--------------------------------------------------------
bool CATSync::is_EnableCATEnergyUpdate_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for EnableCATEnergyUpdate attribute in Write access.
	/*----- PROTECTED REGION ID(CATSync::EnableCATEnergyUpdateStateAllowed_WRITE) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	CATSync::EnableCATEnergyUpdateStateAllowed_WRITE

	//	Not any excluded states for EnableCATEnergyUpdate attribute in read access.
	/*----- PROTECTED REGION ID(CATSync::EnableCATEnergyUpdateStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	CATSync::EnableCATEnergyUpdateStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : CATSync::is_EnableCATSourcePointUpdate_allowed()
 * Description:  Execution allowed for EnableCATSourcePointUpdate attribute
 */
//--------------------------------------------------------
bool CATSync::is_EnableCATSourcePointUpdate_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for EnableCATSourcePointUpdate attribute in Write access.
	/*----- PROTECTED REGION ID(CATSync::EnableCATSourcePointUpdateStateAllowed_WRITE) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	CATSync::EnableCATSourcePointUpdateStateAllowed_WRITE

	//	Not any excluded states for EnableCATSourcePointUpdate attribute in read access.
	/*----- PROTECTED REGION ID(CATSync::EnableCATSourcePointUpdateStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	CATSync::EnableCATSourcePointUpdateStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : CATSync::is_LFBCATTimeFactor_allowed()
 * Description:  Execution allowed for LFBCATTimeFactor attribute
 */
//--------------------------------------------------------
bool CATSync::is_LFBCATTimeFactor_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for LFBCATTimeFactor attribute in Write access.
	/*----- PROTECTED REGION ID(CATSync::LFBCATTimeFactorStateAllowed_WRITE) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	CATSync::LFBCATTimeFactorStateAllowed_WRITE

	//	Not any excluded states for LFBCATTimeFactor attribute in read access.
	/*----- PROTECTED REGION ID(CATSync::LFBCATTimeFactorStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	CATSync::LFBCATTimeFactorStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : CATSync::is_LFBHLSTimeFactor_allowed()
 * Description:  Execution allowed for LFBHLSTimeFactor attribute
 */
//--------------------------------------------------------
bool CATSync::is_LFBHLSTimeFactor_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for LFBHLSTimeFactor attribute in Write access.
	/*----- PROTECTED REGION ID(CATSync::LFBHLSTimeFactorStateAllowed_WRITE) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	CATSync::LFBHLSTimeFactorStateAllowed_WRITE

	//	Not any excluded states for LFBHLSTimeFactor attribute in read access.
	/*----- PROTECTED REGION ID(CATSync::LFBHLSTimeFactorStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	CATSync::LFBHLSTimeFactorStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : CATSync::is_EnableCATMatchOrbit_allowed()
 * Description:  Execution allowed for EnableCATMatchOrbit attribute
 */
//--------------------------------------------------------
bool CATSync::is_EnableCATMatchOrbit_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for EnableCATMatchOrbit attribute in Write access.
	/*----- PROTECTED REGION ID(CATSync::EnableCATMatchOrbitStateAllowed_WRITE) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	CATSync::EnableCATMatchOrbitStateAllowed_WRITE

	//	Not any excluded states for EnableCATMatchOrbit attribute in read access.
	/*----- PROTECTED REGION ID(CATSync::EnableCATMatchOrbitStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	CATSync::EnableCATMatchOrbitStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : CATSync::is_EnableCATSyncMagnets_allowed()
 * Description:  Execution allowed for EnableCATSyncMagnets attribute
 */
//--------------------------------------------------------
bool CATSync::is_EnableCATSyncMagnets_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for EnableCATSyncMagnets attribute in Write access.
	/*----- PROTECTED REGION ID(CATSync::EnableCATSyncMagnetsStateAllowed_WRITE) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	CATSync::EnableCATSyncMagnetsStateAllowed_WRITE

	//	Not any excluded states for EnableCATSyncMagnets attribute in read access.
	/*----- PROTECTED REGION ID(CATSync::EnableCATSyncMagnetsStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	CATSync::EnableCATSyncMagnetsStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : CATSync::is_CATState_allowed()
 * Description:  Execution allowed for CATState attribute
 */
//--------------------------------------------------------
bool CATSync::is_CATState_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for CATState attribute in read access.
	/*----- PROTECTED REGION ID(CATSync::CATStateStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	CATSync::CATStateStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : CATSync::is_HLSState_allowed()
 * Description:  Execution allowed for HLSState attribute
 */
//--------------------------------------------------------
bool CATSync::is_HLSState_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for HLSState attribute in read access.
	/*----- PROTECTED REGION ID(CATSync::HLSStateStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	CATSync::HLSStateStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : CATSync::is_SyncGain_allowed()
 * Description:  Execution allowed for SyncGain attribute
 */
//--------------------------------------------------------
bool CATSync::is_SyncGain_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for SyncGain attribute in Write access.
	/*----- PROTECTED REGION ID(CATSync::SyncGainStateAllowed_WRITE) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	CATSync::SyncGainStateAllowed_WRITE

	//	Not any excluded states for SyncGain attribute in read access.
	/*----- PROTECTED REGION ID(CATSync::SyncGainStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	CATSync::SyncGainStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : CATSync::is_CATTuneHor_allowed()
 * Description:  Execution allowed for CATTuneHor attribute
 */
//--------------------------------------------------------
bool CATSync::is_CATTuneHor_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for CATTuneHor attribute in read access.
	/*----- PROTECTED REGION ID(CATSync::CATTuneHorStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	CATSync::CATTuneHorStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : CATSync::is_CATTuneVer_allowed()
 * Description:  Execution allowed for CATTuneVer attribute
 */
//--------------------------------------------------------
bool CATSync::is_CATTuneVer_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for CATTuneVer attribute in read access.
	/*----- PROTECTED REGION ID(CATSync::CATTuneVerStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	CATSync::CATTuneVerStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : CATSync::is_MatchThreadErrMsg_allowed()
 * Description:  Execution allowed for MatchThreadErrMsg attribute
 */
//--------------------------------------------------------
bool CATSync::is_MatchThreadErrMsg_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for MatchThreadErrMsg attribute in read access.
	/*----- PROTECTED REGION ID(CATSync::MatchThreadErrMsgStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	CATSync::MatchThreadErrMsgStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : CATSync::is_SyncThreadErrMsg_allowed()
 * Description:  Execution allowed for SyncThreadErrMsg attribute
 */
//--------------------------------------------------------
bool CATSync::is_SyncThreadErrMsg_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for SyncThreadErrMsg attribute in read access.
	/*----- PROTECTED REGION ID(CATSync::SyncThreadErrMsgStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	CATSync::SyncThreadErrMsgStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : CATSync::is_MatchThreadErrCnt_allowed()
 * Description:  Execution allowed for MatchThreadErrCnt attribute
 */
//--------------------------------------------------------
bool CATSync::is_MatchThreadErrCnt_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for MatchThreadErrCnt attribute in read access.
	/*----- PROTECTED REGION ID(CATSync::MatchThreadErrCntStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	CATSync::MatchThreadErrCntStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : CATSync::is_SyncThreadErrCnt_allowed()
 * Description:  Execution allowed for SyncThreadErrCnt attribute
 */
//--------------------------------------------------------
bool CATSync::is_SyncThreadErrCnt_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for SyncThreadErrCnt attribute in read access.
	/*----- PROTECTED REGION ID(CATSync::SyncThreadErrCntStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	CATSync::SyncThreadErrCntStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : CATSync::is_MatchThreadCnt_allowed()
 * Description:  Execution allowed for MatchThreadCnt attribute
 */
//--------------------------------------------------------
bool CATSync::is_MatchThreadCnt_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for MatchThreadCnt attribute in read access.
	/*----- PROTECTED REGION ID(CATSync::MatchThreadCntStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	CATSync::MatchThreadCntStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : CATSync::is_SyncThreadCnt_allowed()
 * Description:  Execution allowed for SyncThreadCnt attribute
 */
//--------------------------------------------------------
bool CATSync::is_SyncThreadCnt_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for SyncThreadCnt attribute in read access.
	/*----- PROTECTED REGION ID(CATSync::SyncThreadCntStateAllowed_READ) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	CATSync::SyncThreadCntStateAllowed_READ
	return true;
}


//=================================================
//		Commands Allowed Methods
//=================================================

//--------------------------------------------------------
/**
 *	Method      : CATSync::is_Start_allowed()
 * Description:  Execution allowed for Start attribute
 */
//--------------------------------------------------------
bool CATSync::is_Start_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for Start command.
	/*----- PROTECTED REGION ID(CATSync::StartStateAllowed) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	CATSync::StartStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : CATSync::is_Stop_allowed()
 * Description:  Execution allowed for Stop attribute
 */
//--------------------------------------------------------
bool CATSync::is_Stop_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for Stop command.
	/*----- PROTECTED REGION ID(CATSync::StopStateAllowed) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	CATSync::StopStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : CATSync::is_GotoEnergy_allowed()
 * Description:  Execution allowed for GotoEnergy attribute
 */
//--------------------------------------------------------
bool CATSync::is_GotoEnergy_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for GotoEnergy command.
	/*----- PROTECTED REGION ID(CATSync::GotoEnergyStateAllowed) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	CATSync::GotoEnergyStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : CATSync::is_UpdateEnergy_allowed()
 * Description:  Execution allowed for UpdateEnergy attribute
 */
//--------------------------------------------------------
bool CATSync::is_UpdateEnergy_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for UpdateEnergy command.
	/*----- PROTECTED REGION ID(CATSync::UpdateEnergyStateAllowed) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	CATSync::UpdateEnergyStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : CATSync::is_SyncSourcePointsToHLS_allowed()
 * Description:  Execution allowed for SyncSourcePointsToHLS attribute
 */
//--------------------------------------------------------
bool CATSync::is_SyncSourcePointsToHLS_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for SyncSourcePointsToHLS command.
	/*----- PROTECTED REGION ID(CATSync::SyncSourcePointsToHLSStateAllowed) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	CATSync::SyncSourcePointsToHLSStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : CATSync::is_SwitchLFBCAT_allowed()
 * Description:  Execution allowed for SwitchLFBCAT attribute
 */
//--------------------------------------------------------
bool CATSync::is_SwitchLFBCAT_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for SwitchLFBCAT command.
	/*----- PROTECTED REGION ID(CATSync::SwitchLFBCATStateAllowed) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	CATSync::SwitchLFBCATStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : CATSync::is_SwitchLFBHLS_allowed()
 * Description:  Execution allowed for SwitchLFBHLS attribute
 */
//--------------------------------------------------------
bool CATSync::is_SwitchLFBHLS_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for SwitchLFBHLS command.
	/*----- PROTECTED REGION ID(CATSync::SwitchLFBHLSStateAllowed) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	CATSync::SwitchLFBHLSStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : CATSync::is_ConvertSourcePointsMM_allowed()
 * Description:  Execution allowed for ConvertSourcePointsMM attribute
 */
//--------------------------------------------------------
bool CATSync::is_ConvertSourcePointsMM_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for ConvertSourcePointsMM command.
	/*----- PROTECTED REGION ID(CATSync::ConvertSourcePointsMMStateAllowed) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	CATSync::ConvertSourcePointsMMStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : CATSync::is_ResetSourcePointOffsets_allowed()
 * Description:  Execution allowed for ResetSourcePointOffsets attribute
 */
//--------------------------------------------------------
bool CATSync::is_ResetSourcePointOffsets_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for ResetSourcePointOffsets command.
	/*----- PROTECTED REGION ID(CATSync::ResetSourcePointOffsetsStateAllowed) ENABLED START -----*/
	/* clang-format on */
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	CATSync::ResetSourcePointOffsetsStateAllowed
	return true;
}


/*----- PROTECTED REGION ID(CATSync::CATSyncStateAllowed.AdditionalMethods) ENABLED START -----*/
/* clang-format on */
//	Additional Methods
/* clang-format off */
/*----- PROTECTED REGION END -----*/	//	CATSync::CATSyncStateAllowed.AdditionalMethods

}	//	End of namespace
