//
// file :         rampingthread.h.cpp
//
// description :  thread class
//
// project :      TANGO Device Server
//
// $Author: 
//
// $Revision: 
//
// $Log: 
//
// copyleft :   Sincrotrone Trieste S.C.p.A.
//              Strada Statale 14 - km 163,5 in AREA Science Park
//              34012 Basovizza, Trieste ITALY
// 

#ifndef SEQUENCER_H
#define SEQUENCER_H

#include <util.h>


class Sequencer
{
	private:
		Tango::DeviceProxy *device;
		Tango::DevState state;
		string device_name;
		int32_t timeout;
		bool wait_flag;

		bool init_flag;

		log_buffer<std::string> log_hist;

		omni_mutex *mutex;

		/* parameters that can change at runtime */
		bool safe_mode;
		struct timeval start_time;

	public:
		/* Sensor::Sensor(): initialize object with the property row */
		Sequencer(){}; // default constructor
		Sequencer(std::string &configuration);
		/* rampingthread::~rampingthread(): object destructor */
		~Sequencer();
		Sequencer(const Sequencer &sequencer_obj);

		string get_label(void);

		Tango::DevState get_state(void);
		void start(void);
		Tango::DevState wait(bool blocking); // if blocking wait until finished otherwise return the 
		void stop(void);

		vector<string> get_log_hist(int32_t num_rows);
		void set_log_level(int32_t level);
		int32_t get_log_level(void);

};	/* end class Sensor() */


#endif

/* EOF */
