//
// file :         catsyncthread.h
//
// description :  thread class
//
// project :      TANGO Device Server
//
// $Author: giulio $ 

// $Log: catsyncthread.h,v $

//
//
// copyleft :   Sincrotrone Trieste S.C.p.A.
//              Strada Statale 14 - km 163,5 in AREA Science Park
//              34012 Basovizza, Trieste ITALY
// 

#ifndef CATSYNCTHREAD_H
#define CATSYNCTHREAD_H

#include <omnithread.h>
#include <tango.h>
#include <CATSync.h>

namespace CATSync_ns
{

class catsyncthread : public omni_thread , public Tango::LogAdapter
{

	private:
		int thread_index;  // Indice del thread
		CATSync_ns::CATSync *mycatsync;

	public:
		
		/* catsyncthread::catsyncthread(): initialize init loop */
		catsyncthread(CATSync_ns::CATSync *s, int index) : Tango::LogAdapter(s) {thread_index = index; mycatsync = s; };
		
		/* catsyncthread::~vnthread(): object destructor */
		~catsyncthread() {};
					
	protected:
		/* catsyncthread::run():	start init loop */
		void run(void *);	
		
};	/* end class catsyncthread() */

}

#endif

/* EOF */
