//
// file :         sequencerthread.cpp
//
// description :  bunchnumber thread
//
// project :      TANGO Device Server
//
// $Author: giulio $ 

// copyleft :   Sincrotrone Trieste S.C.p.A.
//              Strada Statale 14 - km 163,5 in AR
//              34012 Basovizza, Trieste ITALY
//

#include <omnithread.h>
#include "CATSync.h"
#include "sequencerthread.h"

namespace CATSync_ns
{

/* 
 *	sequencerthread::run()
 *	Run  
 */		
void sequencerthread::run(void *) 
{
	if ((index < CATSYNC_PRESEQUENCER_IDX) || (index > CATSYNC_PRESEQUENCER_IDX))
		return;

	mycatsync->run_sequencer_flag[index] = true;

	if (index == CATSYNC_PRESEQUENCER_IDX) {
		for (int i = 0; i < mycatsync->pre_sequencer_v.size(); i++) {
			try {
				mycatsync->pre_sequencer_v[i].start();
				mycatsync->pre_sequencer_v[i].wait(true);
			}
			catch(...) {}
		}
	}
	else if (index == CATSYNC_POSTSEQUENCER_IDX) {
		for (int i = 0; i < mycatsync->post_sequencer_v.size(); i++) {
			try {
				mycatsync->post_sequencer_v[i].start();
				mycatsync->post_sequencer_v[i].wait(true);
			}
			catch(...) {}
		}
	}

	mycatsync->abort_sequencer_flag[index] = false;	
	mycatsync->run_sequencer_flag[index] = false;

}

}

